As we can see, we chose to use a Proof of Authority implementation of Ethereum over Proof of Work because our main nodes were on Raspberry Pies and they did not have enough memory to do the initial DAG Ethash calculations for Proof of Work.

## Distributed file system

Currently the Web relies in client-server transactions based on the Internet Protocol (IP) suite. The Hypertext Transfer Protocol (HTTP) is used as basis for communication and for data distribution. In this framework, data is stored in central servers, which can be remotely accessed using the address location. The data can be then distributed, managed, secured and there is possibility to scale the capacity of servers and clients. On the other hand, it means that a central node has complete control of the data. Anyone with control of the server can access, change or remove data stored on it \cite{noon}.

A solution to these weaknesses is the use of a distributed file system protocol. This framework does not use a client-server structure. Instead of that, all nodes are organized as a cluster. This eliminates the need to have a central origin server \cite{late}, as anyone who receives the data becomes a new host of that same that and can then share it with more nodes \cite{medium}.

To our use case, we chose the Interplanetary File System (IPFS). It is an open-source peer-to-peer hypermedia protocol which synthesizes some new and existing innovations on data storage field \cite{noon} with the goal to be as successful as HTTP \cite{late}. The main contribution of IPFS is the simplification, improvement and connection of known techniques (including DHTs, BitTorrent, Git, and SFS) into a single connected system. It makes IPFS a new platform for developing and deploying solutions, including a native system for distributing and versioning large data \cite{Benet2014}.


### Technology selection

As for the distributed file systems, we had two options between Swarm and IPFS. While both offer solutions for the decentralized data storages, we went with IPFS because it is more mature and is not fixed to just one protocol. 

### IPFS implementations

On top of our Ethereum implementation we set up an IPFS server which is how we wanted to bring in distributed file system capabilities into our solution. Using IPFS we could save a hash of the file that we wanted to save on our blockchain to circumvent the tremendous gas it would cost if we were to save the files on the Ethereum blockchain itself.

After installing IPFS on the Raspberry Pie we had to initialize the IPFS path variable, and loosen IPFS node's CORS restrictions:


