The infrastructure network was provided by Fraunhofer Fokus, and was comprised of two Raspberry Pi 3+ Model B running Hypriot OS 1.8.0 and one Sense Hat, an add-on to Raspberry Pi containing a gyroscope, an accelerometer, a magnetometer, Sensors for temperature, humidity, and barometric pressure, a joystick, and an 8×8 LED matrix \cite{pi}.


## Blockchain network

### Technology selection

To select the Blockchain network to use in our project, we first identified the main technologies currently available. After that, we analyzed the characteristics of each network, according to the frameworks presented in \cite{Xu2017} and \cite{wust2017you} . Finally, we selected Ethereum and Hyperledger as the most suitable solutions. We decided on Ethereum because due to three main reasons: first, there is a greater adoption of the technology in the Blockchain development space. This would help us in finding resources for potential problems that might arise. Second, Ethereum has a more mature structure of smart contracts, which we identified to be useful to our use case. Third, Ethereum has a Python implementation, which is a programming language more familiar to the authors.


### Blockchain implementation

The first part of the solution was setting up the private blockchain. While testing out the implementation on our personal laptops, this was done using a proof-of-work Ethash calculation. This was later changed when the implementation was done on the Raspberry Pi as the working memory of the raspberry pie was insufficient to bring up an ethereum node there. Instead we moved our approach to a proof-of-authority implementation of Ethereum.

Both the Ethereum private blockchain network as well as the IPFS server were implemented on one of the Raspberry Pies. The other Raspberry Pie was brought onto the same blockchain, and so the second Raspberry Pie served as the consumer node.

To set up the Ethereum private blockchain we first had to install Geth. Geth is the implementation of the Ethereum protocol. After installing Geth on both Raspberry Pies, we created two accounts coinbase on each Raspberry Pie.  The next step was the setup a Genesis Block json file. Both nodes were then initialized on that Genesis block file. Next in order to bring both nodes to the same network, we generated bootnode key. Then both nodes were initialized on that bootnode to ensure they are on the same network.


