# Introduction

The interest for Blockchain technology emerged with the development of cryptocurrencies (specially Bitcoin). Currently both academia and business sectors identified that Blockchain features can be extended to other fields \cite{underwood2016blockchain}, such as finance, healthcare, manufacturing and public sector \cite{bahga2016blockchain,christidis2016blockchains}. Using Blockchain is possibile to increase the power of current applications and even develop completely new solutions. This is due to the fact that Blockchain networks allow the creation of decentralized applications, which can reduce the number of intermediary agents even in complex transactions. with the use of distributed legder technologies (DLT), Blockchain networks use independent nodes to store, share and synchronise pieces of transactions. Instead of storing all the data in a central node, the transactions are broken in smaller pieces and stored in the local node ledgers \cite{w5tfq}. In this framework, there is not a single node with authority and power to validate a transaction. Blockchain networks use the concept of consensus between the network nodes to validate the state of a transaction. This is done by applying advanced computation algorithms that must be successfully performed by several nodes in the network \cite{baliga2017understanding}.

One of the most proeminent use of Blockchain is to integrate it with Internet of Things (IoT) ecossystem \cite{miraz2018blockchain}. The IoT ecossystem has the capability to connect a giant number of devices and resources in the Internet \cite{jara2014semantic}. These devices have smart capabilities, including remote sensing and/or actuating, and can capture, process and store data, either locally or in other devices on the network, like centralized servers or cloud-based applications. IoT is being widely adopted in manufacturing and industrial applications, such as manufacturing automation, remote sensing and supply chain management \cite{bahga2016blockchain}. As a consequence of the availability and adoption of IoT, there is a huge ammount of data being generated by these devices in a daily basis that need to be securely stored and easily acessed. On the other hand, these devices usually have low computational power and adopt different security protocols, making them vulnerable to exploitations \cite{patton2014uninvited}. Blockchain technologies can play an important role to improve and fortify security and privacy of IoT networks \cite{miraz2018blockchain}.

One of the main weakenesess of Blockchain technology is that is very costly to store large ammount of data into the network. Each Mb stored in a Ethereum network can cost up to USD 4.400, considering ETH quotation for July 13th, 2018 \cite{dapp,coinmarketcap}. To tackle this problem, a solution can be the use of decentralized file storage protocls. These protocols store the data in a decentralized fashion and create immutable and permanent links (called *hashes*) that are stored into the blockchain \cite{web}.

Another issue of storing data in Blockchain networks is to search and retrieve data, as pieces of data are scattered among several nodes, and there is no centralized index to organized the data. A possible solution to this issue is the use of a Linked Data index, a framework based on Semantic Web. A proof-of-concept of this technology was demonstrated in \cite{third2017linked} and showed promising results.

This report shows the final results for the course Advanced Web Technologies, project *Semantic Web of Things With Blockchain*. In this project we were asked to develop an application using a private Blockchain network to store, search and retrieve data generated by IoT devices. On top of this structure, we were proposed to use Semantic Web features to enrich the data generated by the IoT devices and to facilitate the data retrieval. In our project, we developed a prototype of a real-time weather monitoring platform, using an Ethereum private network composed by two Raspberry Pi nodes. The data is stored with IPFS, a decentralized file system built on top of the Blockchain network. The data was then retrieved in a dashboard built using HTML5, CSS3 and D3.js.

This paper is structured as follows: in the section II we will give an overview of related work. Section III describes the development and implementation of our solution. Section IV shows the results of our approach and the challenges faced during the process, and in section V we provide our conclusions and suggestions for future works.
