# Related Work

Recently, Blockchain has experienced dramatic growth in attention and interest from academia. Since this is a new technology, many authors developed studies to make Blockchain easier to be understood by academic researchers and by regular users and companies. As example of these studies, in \cite{risius2017blockchain} the authors identified that the current researches have a strong focus on the technology side, and not in the business side aspects. To tackle this question, the authors proposed a general framework for future academic research on Blockchain systems with focus on multidisciplinary aspects. In a study more focused in the industry \cite{Xu2017}, the authors developed a framework to evaluate different Blockchain networks and Blockchain-based systems to help with the best design and assessment of their impact on software architectures. Also focusing in the business side, in \cite{wust2017you} the authors developed a framework for analyzing scenarios and for identifying the viability of the use of Blockchain networks to solve a particular application problem. The authors applied this methodology in three use cases (Supply Chain Management, Interbank and International Payments, and Decentralized Autonomous Organizations), but their insights can be extrapolated to other business sectors.

Regarding to the use of Blockchain and IoT, many studies cite possible use cases to combine these two technologies \cite{wust2017you}. Theoretical applications were cited in \cite{Christidis2016}, where the authors highlight the possibilites of trusted autonomous communications between different devices. In \cite{pahl2018decision} the authors developed a framework assessing different types of Blockchain platforms (public permissionless, public permissioned and private) according to relevant properties, such as *scalability*, *consensus*, *network size*, *fee*, *block size*, *smart contract* and *security*. This decision framework can be used to guide a potential user to select the network according to their IoT applications. In \cite{Miraz2018} the authors focused on identifying what are the benefits that Blockchain networks provide for the security of an IoT ecossystem.
